/*  
 Test the tft.print() viz embedded tft.write() function

 This sketch used font 2, 4, 7

 Make sure all the display driver and pin connections are correct by
 editing the User_Setup.h file in the TFT_eSPI library folder.

 #########################################################################
 ###### DON'T FORGET TO UPDATE THE User_Setup.h FILE IN THE LIBRARY ######
 #########################################################################
 */


#include <TFT_eSPI.h> // Graphics and font library for ILI9341 driver chip
#include <SPI.h>

#define TFT_GREY 0x5AEB // New colour

TFT_eSPI tft = TFT_eSPI();  // Invoke library
#include "config.h"
AdafruitIO_Feed *C1T = io.feed("C1T");
AdafruitIO_Feed *C2T = io.feed("C2T");
AdafruitIO_Feed *eco21 = io.feed("eco21");

void setup(void) {
  tft.init();
  tft.setRotation(0);
  pinMode(32,INPUT);
  Serial.begin(115200);
  Serial2.begin(115200);
  io.connect();
   while(io.status() < AIO_CONNECTED) {
    Serial.print(".");
    delay(500);
  }
  
  Serial.println();
  Serial.println(io.statusText());
}
void loop() {


  pinMode(32,INPUT);
  String r = Serial2.readString();
  if(r.length()>5){
  String tmp = r.substring(0,r.indexOf(" "));
  String hr = r.substring(r.indexOf(" ")+1,r.indexOf("_"));
  String spo2 = r.substring(r.indexOf("_")+1);
  Serial.println(tmp);
  Serial.println(r);
  C1T->save(tmp.toFloat());
  C2T->save(hr.toFloat());
  eco21->save(spo2.toFloat());
  tft.fillScreen(TFT_BLACK);
  tft.setCursor(0, 0, 2);
  // Set the font colour to be white with a black background, set text size multiplier to 1
  tft.setTextColor(TFT_WHITE,TFT_BLACK);  tft.setTextSize(4);
  // We can now plot text on screen using the "print" class
  tft.println("Scan complete");
  tft.setTextColor(TFT_GREEN,TFT_BLACK);
  tft.setTextSize(2);
  tft.println("Temp: "+tmp);
  tft.setTextColor(TFT_GREEN,TFT_BLACK);
  tft.setTextFont(2);
  tft.println("Heart Rate: "+hr);
  tft.setTextColor(TFT_GREEN,TFT_BLACK);
  tft.setTextFont(2);
  tft.println("SpO2: "+spo2);
  tft.setTextSize(1);
  tft.setTextColor(TFT_BLUE,TFT_BLACK);
  tft.println("You may power off the device now");
  while(1){}
  
  }
  // Fill screen with grey so we can see the effect of printing with and without 
  // a background colour defined
  tft.fillScreen(TFT_BLACK);
  
  // Set "cursor" at top left corner of display (0,0) and select font 2
  // (cursor will move to next line automatically during printing with 'tft.println'
  //  or stay on the line is there is room for the text with tft.print)
  tft.setCursor(0, 0, 2);
  // Set the font colour to be white with a black background, set text size multiplier to 1
  tft.setTextColor(TFT_WHITE,TFT_BLACK);  tft.setTextSize(3);
  // We can now plot text on screen using the "print" class
  tft.println("Hello User!");
  
  // Set the font colour to be yellow with no background, set to font 7
 
  
  // Set the font colour to be green with black background, set to font 4
  tft.setTextColor(TFT_GREEN);
  tft.setTextSize(2);
  tft.println("Place your finger on the Heart Rate sensor and hovering over the thermal camera");
  tft.setTextFont(2);
  tft.setTextColor(TFT_BLUE);
  tft.println("Scan may take 30 seconds to 2 minutes");
   delay(100);
}
